#include <sta/mutex.hpp>


namespace sta
{
    /**
     * @brief Dummy mutex implementation with no access control.
     */
    class DummyMutex : public Mutex
    {
    public:
        void acquire() override {}
        void release() override {}
    };

    static DummyMutex dummyMutex;


    Mutex * Mutex::ALWAYS_FREE = &dummyMutex;
} // namespace sta
