#include <sta/stm32/uart.hpp>
#ifdef STA_STM32_UART_ENABLED

#include <sta/assert.hpp>


namespace sta
{
    STM32UART::STM32UART(UART_HandleTypeDef * handle)
        : handle_{handle}
    {
        STA_ASSERT(handle != nullptr);
    }


    void STM32UART::write(const uint8_t * buffer, size_t size)
    {
        STA_ASSERT(buffer != nullptr);

        HAL_UART_Transmit(handle_, const_cast<uint8_t *>(buffer), size, HAL_MAX_DELAY);
    }
} // namespace sta


#endif // STA_STM32_UART_ENABLED
